Index: /code/branches/network/src/audio/AudioManager.cc
===================================================================
--- /code/branches/network/src/audio/AudioManager.cc	(revision 918)
+++ /code/branches/network/src/audio/AudioManager.cc	(revision 919)
@@ -84,5 +84,5 @@
 	}
 
-	void AudioManager::update()
+	void AudioManager::tick(float dt)
 	{
 		if (bgSounds.size() > 0)
Index: /code/branches/network/src/audio/AudioManager.h
===================================================================
--- /code/branches/network/src/audio/AudioManager.h	(revision 918)
+++ /code/branches/network/src/audio/AudioManager.h	(revision 919)
@@ -3,4 +3,6 @@
 
 #include "AudioIncludes.h"
+
+#include "core/Tickable.h"
 
 #include "AudioPrereqs.h"
@@ -12,5 +14,5 @@
 namespace audio
 {
-	class _AudioExport AudioManager
+  class _AudioExport AudioManager : public orxonox::Tickable
 	{
 	public:
@@ -37,5 +39,5 @@
 
 		// Update
-		void update();
+		void tick(float dt);
 
 		void ambientAdd(std::string file);
Index: /code/branches/network/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/network/src/orxonox/CMakeLists.txt	(revision 918)
+++ /code/branches/network/src/orxonox/CMakeLists.txt	(revision 919)
@@ -1,8 +1,8 @@
 SET( ORXONOX_SRC_FILES
   GraphicsEngine.cc
+  InputHandler.cc
   Main.cc
   Orxonox.cc
-  objects/Tickable.cc
-  SpaceshipSteering.cc
+#  SpaceshipSteering.cc
   hud/HUD.cc
   particle/ParticleInterface.cc
Index: /code/branches/network/src/orxonox/GraphicsEngine.cc
===================================================================
--- /code/branches/network/src/orxonox/GraphicsEngine.cc	(revision 918)
+++ /code/branches/network/src/orxonox/GraphicsEngine.cc	(revision 919)
@@ -35,4 +35,5 @@
 #include <OgreConfigFile.h>
 #include <OgreTextureManager.h>
+#include <OgreRenderWindow.h>
 
 #include "core/Debug.h"
@@ -49,5 +50,7 @@
     this->configPath_ = "";
     this->dataPath_ = "";
-    scene_ = NULL;
+    this->root_ = 0;
+    this->scene_ = 0;
+    this->renderWindow_ = 0;
   }
 
@@ -98,4 +101,5 @@
   {
     root_->initialise(true, "OrxonoxV2");
+    this->renderWindow_ = root_->getAutoCreatedWindow();
     TextureManager::getSingleton().setDefaultNumMipmaps(5);
     ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
@@ -131,4 +135,49 @@
   }
 
+  /**
+    Returns the window handle of the render window.
+    At least the InputHandler uses this to create the OIS::InputManager
+    @return The window handle of the render window
+  */
+  size_t GraphicsEngine::getWindowHandle()
+  {
+    if (this->renderWindow_)
+    {
+      Ogre::RenderWindow *renderWindow = this->root_->getAutoCreatedWindow();
+      size_t windowHnd = 0;
+      renderWindow->getCustomAttribute("WINDOW", &windowHnd);
+      return windowHnd;
+    }
+    else
+      return 0;
+  }
+
+  /**
+    Get the width of the current render window
+    @return The width of the current render window
+  */
+  int GraphicsEngine::getWindowWidth() const
+  {
+    if (this->renderWindow_)
+    {
+      return this->renderWindow_->getWidth();
+    }
+    else
+      return 0;
+  }
+
+  /**
+    Get the height of the current render window
+    @return The height of the current render window
+  */
+  int GraphicsEngine::getWindowHeight() const
+  {
+    if (this->renderWindow_)
+    {
+      return this->renderWindow_->getHeight();
+    }
+    else
+      return 0;
+  }
 
 }
Index: /code/branches/network/src/orxonox/GraphicsEngine.h
===================================================================
--- /code/branches/network/src/orxonox/GraphicsEngine.h	(revision 918)
+++ /code/branches/network/src/orxonox/GraphicsEngine.h	(revision 919)
@@ -33,4 +33,9 @@
       void startRender();
 
+      // several window properties
+      size_t getWindowHandle();
+      int getWindowWidth() const;
+      int getWindowHeight() const;
+
       virtual ~GraphicsEngine();
     private:
@@ -39,4 +44,5 @@
       std::string         dataPath_;    //!< path to data file
       Ogre::SceneManager* scene_;       //!< scene manager of the game
+      Ogre::RenderWindow* renderWindow_;//!< the current render window
 
   };
Index: /code/branches/network/src/orxonox/InputHandler.cc
===================================================================
--- /code/branches/network/src/orxonox/InputHandler.cc	(revision 918)
+++ /code/branches/network/src/orxonox/InputHandler.cc	(revision 919)
@@ -22,5 +22,5 @@
  *      Reto Grieder
  *   Co-authors:
- *      ...
+ *      Some guy writing the example code from Ogre
  *
  */
@@ -34,6 +34,5 @@
 #include "OrxonoxStableHeaders.h"
 
-#include <OgreRenderWindow.h>
-
+#include "Orxonox.h"
 #include "InputHandler.h"
 
@@ -42,10 +41,51 @@
   //using namespace OIS;
 
+  /**
+    @brief Constructor only resets the pointer values to 0.
+  */
   InputHandler::InputHandler()
   {
-    RegisterObject(InputHandler);
-  }
-
-  void InputHandler::initialise(Ogre::RenderWindow *renderWindow)
+    /*if (orxonox::Identifier::isCreatingHierarchy() && !this->getParents())
+        this->createParents();
+    this->setIdentifier(orxonox::ClassManager<InputHandler>::getIdentifier()->registerClass(this->getParents(), "InputHandler", true));
+    if (orxonox::Identifier::isCreatingHierarchy() && this->getParents())
+        this->getParents()->insert(this->getParents()->end(), this->getIdentifier());
+    orxonox::ClassManager<InputHandler>::getIdentifier()->addObject(this);*/
+
+    //RegisterObject(InputHandler);
+
+    this->mouse_       = 0;
+    this->keyboard_    = 0;
+    this->inputSystem_ = 0;
+
+    //this->setConfigValues();
+  }
+
+  void InputHandler::setConfigValues()
+  {
+    //SetConfigValue(codeFire_, 4).description("test value");
+
+    ConfigValueContainer *containercodeFire_ = new ConfigValueContainer("asdfblah", "codeFire_", 4);
+    containercodeFire_->getValue(&codeFire_).description("test");
+    //containercodeFire_->
+  }
+
+  /**
+    @brief The one instance of the InputHandler is stored in this function.
+    @return The pointer to the only instance of the InputHandler
+  */
+  InputHandler* InputHandler::getSingleton()
+  {
+    static InputHandler theOnlyInstance;
+    return &theOnlyInstance;
+  }
+
+  /**
+    @brief Creates the OIS::InputMananger, the keyboard and the mouse
+    @param windowHnd The window handle of the render window
+    @param windowWidth The width of the render window
+    @param windowHeight The height of the render window
+  */
+  void InputHandler::initialise(size_t windowHnd, int windowWidth, int windowHeight)
   {
     if (!inputSystem_)
@@ -53,9 +93,5 @@
       // Setup basic variables
       OIS::ParamList paramList;
-      size_t windowHnd = 0;
       std::ostringstream windowHndStr;
-
-      // Get window handle
-      renderWindow->getCustomAttribute("WINDOW", &windowHnd);
 
       // Fill parameter list
@@ -67,9 +103,6 @@
 
       // If possible create a buffered keyboard
-      // (note: if below line doesn't compile, try:  if (inputSystem_->getNumberOfDevices(OIS::OISKeyboard) > 0) {
       if (inputSystem_->numKeyboards() > 0)
       {
-        //if (inputSystem_->getNumberOfDevices(OIS::OISKeyboard) > 0)
-        //{
         keyboard_ = static_cast<OIS::Keyboard*>(inputSystem_->createInputObject(OIS::OISKeyboard, true));
         keyboard_->setEventCallback(this);
@@ -77,23 +110,19 @@
 
       // If possible create a buffered mouse
-      // (note: if below line doesn't compile, try:  if (inputSystem_->getNumberOfDevices(OIS::OISMouse) > 0) {
       if (inputSystem_->numMice() > 0 )
       {
-        //if (inputSystem_->getNumberOfDevices(OIS::OISMouse) > 0)
-        //{
         mouse_ = static_cast<OIS::Mouse*>(inputSystem_->createInputObject(OIS::OISMouse, true));
         mouse_->setEventCallback(this);
 
-        // Get window size
-        unsigned int width, height, depth;
-        int left, top;
-        renderWindow->getMetrics(width, height, depth, left, top);
-
         // Set mouse region
-        this->setWindowExtents(width, height);
+        this->setWindowExtents(windowWidth, windowHeight);
       }
     }
   }
 
+  /**
+    @brief Updates the InputHandler
+    @param dt Delta time
+  */
   void InputHandler::tick(float dt)
   {
@@ -110,4 +139,10 @@
   }
 
+  /**
+    @brief Adjusts the mouse window metrics.
+    This method has to be called every time the size of the window changes.
+    @param width The new width of the render window
+    @param height the new height of the render window
+  */
   void InputHandler::setWindowExtents(int width, int height)
   {
@@ -118,9 +153,19 @@
   }
 
+  /**
+    @brief Event handler for the keyPressed Event.
+    @param e Event information
+  */
   bool InputHandler::keyPressed(const OIS::KeyEvent &e)
   {
-    return true;
-  }
-
+    if (e.key == OIS::KC_ESCAPE)
+      Orxonox::getSingleton()->abortRequest();
+    return true;
+  }
+
+  /**
+    @brief Event handler for the keyReleased Event.
+    @param e Event information
+  */
   bool InputHandler::keyReleased(const OIS::KeyEvent &e)
   {
@@ -128,4 +173,8 @@
   }
 
+  /**
+    @brief Event handler for the mouseMoved Event.
+    @param e Event information
+  */
   bool InputHandler::mouseMoved(const OIS::MouseEvent &e)
   {
@@ -133,4 +182,9 @@
   }
 
+  /**
+    @brief Event handler for the mousePressed Event.
+    @param e Event information
+    @param id The ID of the mouse button
+  */
   bool InputHandler::mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id)
   {
@@ -138,4 +192,9 @@
   }
 
+  /**
+    @brief Event handler for the mouseReleased Event.
+    @param e Event information
+    @param id The ID of the mouse button
+  */
   bool InputHandler::mouseReleased(const OIS::MouseEvent &e, OIS::MouseButtonID id)
   {
Index: /code/branches/network/src/orxonox/InputHandler.h
===================================================================
--- /code/branches/network/src/orxonox/InputHandler.h	(revision 918)
+++ /code/branches/network/src/orxonox/InputHandler.h	(revision 919)
@@ -39,20 +39,22 @@
 #include <OIS/OISKeyboard.h>
 
-#include <OgrePrerequisites.h>
-
 #include "OrxonoxPrereqs.h"
+//#include "core/OrxonoxClass.h"
 #include "core/Tickable.h"
 
 namespace orxonox
 {
-  class _OrxonoxExport InputHandler : public Tickable, public OIS::KeyListener,
-                                      public OIS::MouseListener
+  class _OrxonoxExport InputHandler
+        : public Tickable,
+          public OIS::KeyListener, public OIS::MouseListener
   {
   public:
-    InputHandler();
 
-    void initialise(Ogre::RenderWindow *renderWindow);
+    void initialise(size_t windowHnd, int windowWidth, int windowHeight);
     void tick(float dt);
     void setWindowExtents(int width, int height);
+
+    OIS::Mouse    *getMouse()    { return this->mouse_   ; }
+    OIS::Keyboard *getKeyboard() { return this->keyboard_; }
 
     // input events
@@ -63,8 +65,21 @@
 		bool keyReleased  (const OIS::KeyEvent   &arg);
 
+    static InputHandler* getSingleton();
+
+    void setConfigValues();
+
   private:
+    // don't mess with a Singleton
+    InputHandler ();
+    InputHandler (const InputHandler&) { }
+    ~InputHandler() { }
+
     OIS::InputManager *inputSystem_;
     OIS::Keyboard     *keyboard_;
     OIS::Mouse        *mouse_;
+
+    // Key bindings
+    int codeFire_;
+    OIS::KeyCode codeMoveForward_;
 
   };
Index: /code/branches/network/src/orxonox/Orxonox.cc
===================================================================
--- /code/branches/network/src/orxonox/Orxonox.cc	(revision 918)
+++ /code/branches/network/src/orxonox/Orxonox.cc	(revision 919)
@@ -67,8 +67,6 @@
 network::Server *server_g;
 
-
 // objects
 #include "tools/Timer.h"
-#include "tools/OrxListener.h"
 #include "core/ArgReader.h"
 #include "core/Debug.h"
@@ -79,4 +77,6 @@
 #include "objects/weapon/BulletManager.h"
 
+#include "InputHandler.h"
+
 #include "Orxonox.h"
 
@@ -95,7 +95,8 @@
     this->auMan_ = 0;
     this->singletonRef_ = 0;
-    this->keyboard_ = 0;
-    this->mouse_ = 0;
-    this->inputManager_ = 0;
+    //this->keyboard_ = 0;
+    //this->mouse_ = 0;
+    //this->inputManager_ = 0;
+    this->inputHandler_ = 0;
     this->frameListener_ = 0;
     this->root_ = 0;
@@ -187,6 +188,4 @@
     //setupInputSystem();
     
-    createFrameListener();
-    
     startRenderLoop();
   }
@@ -201,5 +200,4 @@
     setupInputSystem();
     
-    createFrameListener();
     server_g->open();
     
@@ -215,6 +213,4 @@
     setupScene();
     setupInputSystem();
-    
-    createFrameListener();
     
     startRenderLoop();
@@ -380,5 +376,9 @@
   void Orxonox::setupInputSystem()
   {
-    size_t windowHnd = 0;
+    inputHandler_ = InputHandler::getSingleton();
+    inputHandler_->initialise(ogre_->getWindowHandle(),
+          ogre_->getWindowWidth(), ogre_->getWindowHeight());
+
+    /*size_t windowHnd = 0;
     std::ostringstream windowHndStr;
     OIS::ParamList pl;
@@ -403,29 +403,5 @@
     {
       throw new Ogre::Exception(42, e.eText, "OrxApplication::setupInputSystem");
-    }
-  }
-
-  // FIXME we actually want to do this differently...
-  void Orxonox::createFrameListener()
-  {
-    frameListener_ = new OrxListener(keyboard_, auMan_, mode_);
-  }
-
-  void Orxonox::startRenderLoop()
-  {
-    // FIXME
-    // this is a hack!!!
-    // the call to reset the mouse clipping size should probably be somewhere
-    // else, however this works for the moment.
-    unsigned int width, height, depth;
-    int left, top;
-    ogre_->getRoot()->getAutoCreatedWindow()->getMetrics(width, height, depth, left, top);
-
-    if(mode_!=CLIENT){
-      const OIS::MouseState &ms = mouse_->getMouseState();
-      ms.width = width;
-      ms.height = height;
-    }
-    mainLoop();
+    }*/
   }
 
@@ -444,5 +420,5 @@
     means of the recent most dt_n-1, dt_n-2, etc.
   */
-  void Orxonox::mainLoop()
+  void Orxonox::startRenderLoop()
   {
     // use the ogre timer class to measure time.
Index: /code/branches/network/src/orxonox/Orxonox.h
===================================================================
--- /code/branches/network/src/orxonox/Orxonox.h	(revision 918)
+++ /code/branches/network/src/orxonox/Orxonox.h	(revision 919)
@@ -42,6 +42,6 @@
       inline GraphicsEngine* getOgrePointer()              { return ogre_; };
       inline audio::AudioManager* getAudioManagerPointer() { return auMan_; };
-      inline OIS::Keyboard* getKeyboard()                  { return this->keyboard_; }
-      inline OIS::Mouse* getMouse()                        { return this->mouse_; }
+      //inline OIS::Keyboard* getKeyboard()                  { return this->keyboard_; }
+      //inline OIS::Mouse* getMouse()                        { return this->mouse_; }
       inline BulletManager* getBulletMgr()                 { return this->bulletMgr_; }
 
@@ -64,7 +64,5 @@
       void setupScene();
       void setupInputSystem();
-      void createFrameListener();
       void startRenderLoop();
-      void mainLoop();
       void updateTimers(float);
       float calculateEventTime(unsigned long, std::deque<unsigned long>&);
@@ -77,7 +75,8 @@
       BulletManager*        bulletMgr_;     //!< Keeps track of the thrown bullets
       static Orxonox*       singletonRef_;
-      OIS::Keyboard*        keyboard_;
-      OIS::Mouse*           mouse_;
-      OIS::InputManager*    inputManager_;
+      InputHandler*         inputHandler_;
+      //OIS::Keyboard*        keyboard_;
+      //OIS::Mouse*           mouse_;
+      //OIS::InputManager*    inputManager_;
       OrxListener*          frameListener_;
       Ogre::Root*           root_;
Index: /code/branches/network/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/branches/network/src/orxonox/OrxonoxPrereqs.h	(revision 918)
+++ /code/branches/network/src/orxonox/OrxonoxPrereqs.h	(revision 919)
@@ -68,4 +68,5 @@
   class Camera;
   class GraphicsEngine;
+  class InputHandler;
   class Mesh;
   class Model;
Index: /code/branches/network/src/orxonox/core/CMakeLists.txt
===================================================================
--- /code/branches/network/src/orxonox/core/CMakeLists.txt	(revision 918)
+++ /code/branches/network/src/orxonox/core/CMakeLists.txt	(revision 919)
@@ -17,4 +17,5 @@
   Executor.cc
   XMLPort.cc
+  Tickable.cc
 )
 
Index: /code/branches/network/src/orxonox/objects/Fighter.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/Fighter.cc	(revision 918)
+++ /code/branches/network/src/orxonox/objects/Fighter.cc	(revision 919)
@@ -37,7 +37,8 @@
 #include "util/tinyxml/tinyxml.h"
 #include "util/String2Number.h"
-#include "../core/CoreIncludes.h"
-#include "../Orxonox.h"
-#include "../particle/ParticleInterface.h"
+#include "core/CoreIncludes.h"
+#include "Orxonox.h"
+#include "InputHandler.h"
+#include "particle/ParticleInterface.h"
 #include "weapon/AmmunitionDump.h"
 #include "weapon/BarrelGun.h"
@@ -254,7 +255,7 @@
         if (!this->setMouseEventCallback_)
         {
-            if (Orxonox::getSingleton()->getMouse())
+            if (InputHandler::getSingleton()->getMouse())
             {
-                Orxonox::getSingleton()->getMouse()->setEventCallback(this);
+                InputHandler::getSingleton()->getMouse()->setEventCallback(this);
                 this->setMouseEventCallback_ = true;
             }
@@ -263,6 +264,6 @@
         WorldEntity::tick(dt);
 
-        OIS::Keyboard* mKeyboard = Orxonox::getSingleton()->getKeyboard();
-        OIS::Mouse* mMouse = Orxonox::getSingleton()->getMouse();
+        OIS::Keyboard* mKeyboard = InputHandler::getSingleton()->getKeyboard();
+        OIS::Mouse* mMouse = InputHandler::getSingleton()->getMouse();
 
         mKeyboard->capture();
Index: /code/branches/network/src/orxonox/objects/NPC.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/NPC.cc	(revision 918)
+++ /code/branches/network/src/orxonox/objects/NPC.cc	(revision 919)
@@ -85,5 +85,5 @@
   void NPC::tick(float dt)
   {
-
+    update();
     this->setVelocity(0.995*this->getVelocity() + this->getAcceleration()*dt);
     this->translate(this->getVelocity()*dt);
Index: /code/branches/network/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 918)
+++ /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 919)
@@ -39,8 +39,9 @@
 #include "util/String2Number.h"
 #include "util/Math.h"
-#include "../core/CoreIncludes.h"
-#include "../core/Debug.h"
-#include "../Orxonox.h"
-#include "../particle/ParticleInterface.h"
+#include "core/CoreIncludes.h"
+#include "core/Debug.h"
+#include "Orxonox.h"
+#include "InputHandler.h"
+#include "particle/ParticleInterface.h"
 #include "Projectile.h"
 #include "core/XMLPort.h"
@@ -400,7 +401,7 @@
         if (!this->setMouseEventCallback_)
         {
-            if (Orxonox::getSingleton()->getMouse())
+            if (InputHandler::getSingleton()->getMouse())
             {
-                Orxonox::getSingleton()->getMouse()->setEventCallback(this);
+                InputHandler::getSingleton()->getMouse()->setEventCallback(this);
                 this->setMouseEventCallback_ = true;
             }
@@ -427,6 +428,6 @@
         }
 
-        OIS::Keyboard* mKeyboard = Orxonox::getSingleton()->getKeyboard();
-        OIS::Mouse* mMouse = Orxonox::getSingleton()->getMouse();
+        OIS::Keyboard* mKeyboard = InputHandler::getSingleton()->getKeyboard();
+        OIS::Mouse* mMouse = InputHandler::getSingleton()->getMouse();
 
         mKeyboard->capture();
Index: de/branches/network/src/orxonox/tools/OrxListener.cc
===================================================================
--- /code/branches/network/src/orxonox/tools/OrxListener.cc	(revision 918)
+++ 	(revision )
@@ -1,62 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-#include "OrxonoxStableHeaders.h"
-
-#include "core/CoreIncludes.h"
-#include "objects/NPC.h"
-#include "audio/AudioManager.h"
-#include "Orxonox.h"
-#include "OrxListener.h"
-
-namespace orxonox
-{
-  OrxListener::OrxListener(OIS::Keyboard *keyboard, audio::AudioManager*  auMan, gameMode mode)
-  {
-    keyboard_ = keyboard;
-    mode_=mode;
-    auMan_ = auMan;
-  }
-
-  void OrxListener::tick(float dt)
-  {
-    auMan_->update();
-    updateAI();
-
-    keyboard_->capture();
-    if (keyboard_->isKeyDown(OIS::KC_ESCAPE))
-      Orxonox::getSingleton()->abortRequest();
-  }
-
-  void OrxListener::updateAI()
-  {
-    for(Iterator<NPC> it = ObjectList<NPC>::start(); it; ++it)
-    {
-      it->update();
-    }
-  }
-}
Index: de/branches/network/src/orxonox/tools/OrxListener.h
===================================================================
--- /code/branches/network/src/orxonox/tools/OrxListener.h	(revision 918)
+++ 	(revision )
@@ -1,60 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-/*!
-    @file
-    Hack for the AI and server/client update.
-*/
-
-#ifndef _OrxListener_H__
-#define _OrxListener_H__
-
-#include <OIS/OISPrereqs.h>
-
-#include "../OrxonoxPrereqs.h"
-#include "audio/AudioPrereqs.h"
-#include "Orxonox.h"
-#include "core/Tickable.h"
-
-namespace orxonox
-{
-  class OrxListener : public Tickable
-  {
-    public:
-      OrxListener(OIS::Keyboard *keyboard, audio::AudioManager*  auMan, gameMode mode);
-
-      void tick(float dt);
-      void updateAI();
-
-    private:
-      gameMode mode_;
-      audio::AudioManager* auMan_;
-      OIS::Keyboard *keyboard_;
-  };
-}
-
-#endif /* _OrxListener_H__ */
Index: /code/branches/network/visual_studio/vc8/orxonox.vcproj
===================================================================
--- /code/branches/network/visual_studio/vc8/orxonox.vcproj	(revision 918)
+++ /code/branches/network/visual_studio/vc8/orxonox.vcproj	(revision 919)
@@ -640,8 +640,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\orxonox\tools\OrxListener.cc"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\orxonox\tools\Timer.cc"
 					>
@@ -810,8 +806,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\orxonox\tools\OrxListener.h"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\orxonox\tools\Timer.h"
 					>